/* 
  Copyright (C) 1998 Christofer Edvardsen and Norbert Preining

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "smmgr.h"

int repl_imon(char* const* s) {
	char tmpstr[256];
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
 	setiospeed(B38400); 
/*	setiospeed(B115200);*/
	/* reset clock but do NOT write libfile */
	sendstring("AT+MCS=1", NULL,NULL);
	resetclock(0);
	sprintf(tmpstr,"AT+MCF=%d+MCV=%d+MCM=%d+MCD=%d+MCR=%d+MVD=%d+MCP=%04d",
		s_fax,s_voice,s_monitor,s_remote,s_answer,s_recordtime,s_password);
	sendstring(tmpstr, NULL,NULL);
	if (modemtypes[s_modemtype].id == USR_MESSAGE_PRO) {
		sprintf(tmpstr,"AT+MCT=%d+MCG=%d",s_tollsaver,s_loudness);
		sendstring(tmpstr,NULL, NULL);
	}
	sendstring("AT+MCW", NULL,NULL);
	writetolog("im on");
	return(0);
}
int repl_imon_proper(char* const* s) {
	char tmpstr[256];
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
 	setiospeed(B38400); 
/*	setiospeed(B115200);*/
	sprintf(tmpstr,"AT+MCF=%d+MCV=%d+MCM=%d+MCD=%d+MCR=%d+MVD=%d+MCP=%04d",
		s_fax,s_voice,s_monitor,s_remote,s_answer,s_recordtime,s_password);
	sendstring(tmpstr, NULL,NULL);
	sprintf(tmpstr,"AT+MFI=\"%s\"",s_identity);
	sendstring(tmpstr, NULL,NULL);
	if (modemtypes[s_modemtype].id == USR_MESSAGE_PRO) {
		sprintf(tmpstr,"AT+MCT=%d+MCG=%d",s_tollsaver,s_loudness);
		sendstring(tmpstr,NULL, NULL);
	}
	/* reset clock but do NOT write libfile */
	resetclock(0);
	/* sendstring("AT&W", 500,NULL); */
	sendstring("AT+MCW", NULL,NULL);
	writetolog("im on");
	return(0);
}
int repl_imoff(char* const* s) {
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
 	setiospeed(B38400); 
/*	setiospeed(B115200);*/
/* This should REALLY be checked!!! */
	sendstring("AT+MCW", NULL,NULL);
 	sendstring("AT+MCS=0", NULL,NULL); 
	sendstring("AT&W", NULL, NULL);
	writetolog("im off");
	repl_closedevice(NULL);
	return(0);
}
/* int repl_getall(char* const* s) { */
/* 	if (!have_msginfos) { */
/* 		logit(L_INFO,"No msginfos - calling getmsginfo!\n"); */
/* 		repl_getmsginfo(NULL); */
/* 	} */
/* 	if ( ( nr_voice + nr_fax ) > 0 ) { */
/* 		readclock(); */
/* 		setiospeed(B115200); */
/* 		msgtofile(); */
/* 	} */
/* 	writetolog("downloaded all messages"); */
/* 	return(0); */
/* } */
/* int repl_getnew(char* const* s) { */
/* 	if (!have_msginfos) { */
/* 		logit(L_INFO,"No msginfos - calling getmsginfo!\n"); */
/* 		repl_getmsginfo(NULL); */
/* 	} */
/* 	newtofile(); */
/* 	return(0); */
/* } */
/* int repl_getone(char* const* s) { */
/* 	char *p; */
/* 	long int l; */

/* 	if (!have_msginfos) { */
/* 		logit(L_INFO,"No msginfos - calling getmsginfo!\n"); */
/* 		repl_getmsginfo(NULL); */
/* 	} */
/* 	l = strtol(*s,&p,10); */
/* 	if (p != NULL && ((l > 0) || (l <= ( nr_voice + nr_fax ))) ) { */
/* 		readclock(); */
/* 		setiospeed(B115200); */
/* 		onetofile(l); */
/* 	} else { */
/* 		logit(L_ERROR,"getone: index out of range: %ld\n",l); */
/* 		return(1); */
/* 	} */
/* 	writetolog("downloaded one messages"); */
/* 	return(0); */
/* } */
int repl_get(char* const* s) {
	char *p;
	long int l;

	if (!have_msginfos) {
		logit(L_INFO,"No msginfos - calling getmsginfo!\n");
		repl_getmsginfo(NULL);
	}
	if (strcasecmp(*s,"all") == 0) {
		if (nr_msgs == 0) {
			logit(L_INFO,"No messages!\n");
			return(0);
		}
		readclock();
		setiospeed(B115200);
		msgtofile();
		writetolog("downloaded all messages");
		return(0);
	}
	if (strcasecmp(*s,"new") == 0) {
		if (nr_fax_new + nr_voice_new == 0) {
			logit(L_INFO,"No new messages!\n");
			return(0);
		}
		newtofile();
		writetolog("downloaded new messages");
		return(0);
	}
	if (strcasecmp(*s,"newvoice") == 0) {
		if (nr_voice_new == 0) {
			logit(L_INFO,"No new voice messages!\n");
			return(0);
		}
		newvoicetofile();
		writetolog("downloaded new voice messages");
		return(0);
	}
	if (strcasecmp(*s,"newfax") == 0) {
		if (nr_fax_new == 0) {
			logit(L_INFO,"No new fax messages!\n");
			return(0);
		}
		newfaxtofile();
		writetolog("downloaded new fax messages");
		return(0);
	}
	if (strcasecmp(*s,"greeting") == 0) {
		transfer_special(0);
		writetolog("downloaded greeting message");
		return(0);
	}
	if (strcasecmp(*s,"full") == 0) {
		transfer_special(1);
		writetolog("downloaded full message");
		return(0);
	}
	l = strtol(*s,&p,10);
	if (p != NULL && (l > 0) && (l <= nr_msgs) ) {
		readclock();
		setiospeed(B115200);
		onetofile(l);
	} else {
		logit(L_ERROR,"get: index out of range: %ld\n",l);
		return(1);
	}
	writetolog("downloaded one message");
	return(0);
}
int repl_clear(char* const* s) {
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
	logit(L_INFO,"Erasing modem memory... This takes about half a minute.\n");
	setiospeed(B115200);
	sendstring("AT+MEM", NULL,NULL);
	writetolog("modem memory erased");
	/* Reseting clock AND (arg=1) write libfile! */
	resetclock(1);
        if (have_msginfos) {
                free(msginfos);
                have_msginfos = 0;
        }
	return(0);
}
int repl_ulg(char* const* s) {
	modemval tmp;
	
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
 	setiospeed(B38400); 
/*	setiospeed(B115200);*/ /* ???????????? */
	tmp=sendstring("AT+MVC=0",NULL,"CONNECT");
	if (tmp != M_OK) {
		logit(L_ERROR,"Cannot upload greeting file!\n");
		return(1);
	}
	ulfile(*s);
	usleep(5000000);
	return(0);
}
int repl_ulf(char* const* s) {
	modemval tmp;
	
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
 	setiospeed(B38400); 
/*	setiospeed(B115200); */ /* ???????????? */
	tmp = sendstring("AT+MVC=1",NULL,"CONNECT");
	if (tmp != M_OK) {
		logit(L_ERROR,"Cannot upload FullMessage file!\n");
		return(1);
	}
	ulfile(*s);
	usleep(5000000);
	return(0);
}
int repl_recg(char* const* s) {
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
	printf("Press Ctrl-C to stop recording.\n");
	writetolog("new greeting message recorded");
 	setiospeed(B38400); 
/*	setiospeed(B115200);*/ /* ???????????? */
	sendstring("AT+MVR=0", NULL,NULL);
	return(0);
}
int repl_recf(char* const* s) {
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
	printf("Press Ctrl-C to stop recording.\n");
	writetolog("new memory full message recorded");
 	setiospeed(B38400); 
/*	setiospeed(B115200);*/ /* ???????????? */
	sendstring("AT+MVR=1", NULL,NULL);
	return(0);
}
int repl_view(char* const* s) {
        long int l;
        char *p,str[5],*t;

        if (!have_msginfos) {
                logit(L_INFO,"No msginfos - calling getmsginfo!\n");
                repl_getmsginfo(NULL);
        }
	if (strcasecmp(*s,"all") == 0) {
		if (nr_fax == 0) {
			logit(L_INFO,"No fax messages!\n");
			return(0);
		}
		for (l=0;l<nr_msgs;l++) {
			if (is_fax(l)) {
				sprintf(str,"%3ld",l+1);
				t = &(str[0]);
				repl_view(&t);
			}
		}
		return(0);
	}
	if (strcasecmp(*s,"new") == 0) {
		if (nr_fax_new == 0) {
			logit(L_INFO,"No new fax messages!\n");
			return(0);
		}
		for (l=0;l<nr_msgs;l++) {
			if (is_new_or_unknown(l) && is_fax(l)) {
				sprintf(str,"%3ld",l+1);
				t = &(str[0]);
				repl_view(&t);
			}
		}
		return(0);
	}
        l = strtol(*s,&p,10);
        if (p == NULL || (l <= 0) || (l > ( nr_voice + nr_fax )) ) {
                logit(L_ERROR,"view: index out of range: %ld\n",l);
                return(1);
        }
        if (msginfos[l-1].type != T_FAX) {
                logit(L_ERROR,"view: can only view fax message!\n");
                return(1);
        }
	return view_fax(l);
}	
int repl_play(char* const* s) {
	char tmpstr[256];
	long int l;
	char *p,str[5],*t;
	
	if (!have_msginfos) {
		logit(L_INFO,"No msginfos - calling getmsginfo!\n");
		repl_getmsginfo(NULL);
	}
	if (strcasecmp(*s,"all") == 0) {
		if (nr_voice == 0) {
			logit(L_INFO,"No voice messages!\n");
			return(0);
		}
		for (l=0;l<nr_msgs;l++) {
			if (is_voice(l)) {
				sprintf(str,"%3ld",l+1);
				t = &(str[0]);
				repl_play(&t);
			}
		}
		return(0);
	}
	if (strcasecmp(*s,"new") == 0) {
		if (nr_voice_new == 0) {
			logit(L_INFO,"No new voice messages!\n");
			return(0);
		}
		for (l=0;l<nr_msgs;l++) {
			if (is_new_or_unknown(l) && is_voice(l)) {
				sprintf(str,"%3ld",l+1);
				t = &(str[0]);
				repl_play(&t);
			}
		}
		return(0);
	}
	if (strcasecmp(*s,"greeting") == 0) {
		return repl_playg(NULL);
	}
	if (strcasecmp(*s,"full") == 0 ) {
		return repl_playf(NULL);
	}
	l = strtol(*s,&p,10);
	if (p == NULL || (l <= 0) || (l > ( nr_voice + nr_fax )) ) {
		logit(L_ERROR,"play: index out of range: %ld\n",l);
		return(1);
	}
	if (msginfos[l-1].type != T_VOICE) {
		logit(L_ERROR,"play: cannot only play voice message!\n");
		return(1);
	}
	if (s_out_card == 1) {
		return play_soundcard(l);
	}
	setiospeed(B115200);
	sprintf(tmpstr,"AT+MVP=%ld",l);
	/* install special signal handler */
	if (signal(SIGINT, interrupt_play_handler) == SIG_ERR) {
		logit(L_ERROR,"Couldn't install signal handler.\n");
	}
	sendstring(tmpstr, NULL,NULL);
	/* restoring signal handler */
	signal(SIGINT, termination_handler);
	return(0);
}
int repl_playg(char* const* s) {
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
	if (s_out_card == 1) {
		return play_soundcard(0);
	}
	setiospeed(B115200);
	/* install special signal handler */
	if (signal(SIGINT, interrupt_play_handler) == SIG_ERR) {
		logit(L_ERROR,"Couldn't install signal handler.\n");
	}
	sendstring("AT+MVP=0", NULL,NULL);
	/* restoring signal handler */
	signal(SIGINT, termination_handler);
	return(0);
}
int repl_playf(char* const* s) {
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
	if (s_out_card == 1) {
		return play_soundcard(255);
	}
	setiospeed(B115200);
	/* install special signal handler */
	if (signal(SIGINT, interrupt_play_handler) == SIG_ERR) {
		logit(L_ERROR,"Couldn't install signal handler.\n");
	}
	sendstring("AT+MVP=255", NULL,NULL);
	/* restoring signal handler */
	signal(SIGINT, termination_handler);
	return(0);
}
int repl_list(char* const* s) {
	if (!have_msginfos) {
		logit(L_INFO,"No msginfos - calling getmsginfo!\n");
		repl_getmsginfo(NULL);
	}
 	setiospeed(B19200); 
/*	setiospeed(B115200);*/
	printf("Number of new messages: voice %d fax %d\n",
	       nr_voice_new,nr_fax_new);
	printf("Number of total messages: voice %d fax %d\n",nr_voice,nr_fax);
	printf("Total memory: %dMb\n",total_memory);
	printf("Memory full up to %d%%!\n",percentfull);
	printf("Incoming message present: %s\n",inmsg?"yes":"no");
	printf("Full message present: %s\n",fullmsg?"yes":"no");
	listmsg();
	return(0);
}
int repl_report(char* const* s) {
	if (!have_msginfos) {
		logit(L_INFO,"No msginfos - calling getmsginfo!\n");
		repl_getmsginfo(NULL);
	}
 	setiospeed(B19200); 
/*	setiospeed(B115200); */
	printf("Number of new messages: voice %d fax %d\n",
	       nr_voice_new,nr_fax_new);
	printf("Number of total messages: voice %d fax %d\n",nr_voice,nr_fax);
	printf("Total memory: %dMb\n",total_memory);
	printf("Memory full up to %d%%!\n",percentfull);
	printf("Incoming message present: %s\n",inmsg?"yes":"no");
	printf("Full message present: %s\n",fullmsg?"yes":"no");
	report_msgs();
	return(0);
}
int repl_clock(char* const* s) {
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
 	setiospeed(B38400); 
/*	setiospeed(B115200);*/
	readclock();
	return(0);
}
int repl_freenr(char* const* s) {
	c_firstfree=freenr();
        logit(L_INFO,"First free message file number: %d\n",c_firstfree);
	return(0);
}
int repl_repl(char* const* s) {
	return(start_repl());
}
int repl_quit(char* const* s) {
	exit(0);
}
int repl_savepage(char* const* s) {
	char *p;
	long int l;
	char fn[20];
	l = strtol(*s,&p,10);
	if (p == NULL || l > 255 || l < 0) {
		logit(L_ERROR,"syntax error: savepage <page-number>\n");
		return(1);
	} else {
		sprintf(fn,"page-%d.data",(int)l);
		savepagetofile((int)l,fn);
		return(0);
	}
}
int repl_getmsginfo(char* const* s) {
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
 	setiospeed(B19200); 
/*	setiospeed(B115200);*/
	getmsginfo();
	readclock();
	have_msginfos = 1;
	return(0);
}
int repl_parseconfig(char* const* s) {
	return(parseconfigfile());
}
int repl_initdevice(char* const* s) {
	char tmpstr[128];
	
	opendev();
	sprintf(tmpstr,"%s",s_init);
	if ( sendstring(tmpstr, NULL, NULL) == M_NORESPONSE) {
		logit(L_ERROR,"Modem not responding.\n");
		exit(1);
	}
	if ( sendstring("AT+MCS=1", NULL, NULL) == M_NORESPONSE) {
		logit(L_ERROR,"Modem not responding.\n");
		exit(1);
	}
	device_initialized = 1;
	return(0);
}
int repl_closedevice(char* const* s) {
	/* Call closedev in any case, because lock_file MUST be removed! */
	closedev();
	if (have_msginfos) {
		free(msginfos);
		have_msginfos = 0;
	}
	device_initialized = 0;
	return(0);
}
int repl_helpall(char* const* s) {
	repl_help(s);
	repl_helpsettings(s);
	return(0);
}
int repl_help(char* const* s) {
	int i;
	Tcomdef *cd = &comdef[0];
	char tmpstr[256];
	
	printf("smmgr %s\n%s\nUsage:\nsmmgr [noconfig] [<commands> ...] [-h|-help|--help] [-v|-version|--version]\nCommands:\n",
	       VERSION, COPYRIGHT);
	while (cd->name != NULL) {
		strcpy(tmpstr,cd->name);
		for (i=0;i<cd->takearg;i++) strcat(tmpstr," <arg>");
		printf("  %-17s",tmpstr);
/* 		printf("\t%-15s",cd->name); */
/* 		strcpy(tmp,""); */
/* 		for (i=0;i<cd->takearg;i++) printf(" <arg>"); */
		printf(": %-30s\n",cd->description);
		cd++;
	}
/* 	printf("Settings:\n"); */
/* 	while (set->name != NULL) { */
/* 		printf("  %-17s: %-30s\n",set->name,set->description); */
/* 		fflush(stdout); */
/* 		set++; */
/* 	} */
	return(0);
}
int repl_helpsettings(char* const* s) {
	Setting *set = &comdef_settings[0];

	printf("Settings:\n");
	while (set->name != NULL) {
		printf("  %-17s: %-30s\n",set->name,set->description);
		fflush(stdout);
		set++;
	}
	return(0);
}
int repl_settings(char* const* s) {
	printf("smmgr: current settings:\n");
	printf("ModemType: %s\n",modemtypes[s_modemtype].modemname);
	printf("s_fax=%d\ns_voice=%d\ns_monitor=%d\ns_remote=%d\n",
	       s_fax,s_voice,s_monitor,s_remote);
	printf("s_answer=%d\ns_verbose=%d\ns_identity=%s\ns_device=%s\n",
	       s_answer,s_verbose,s_identity,s_device);
	printf("s_password=%d\n",
	       s_password);
	printf("s_init=%s\ns_faxdir=%s\ns_voicedir=%s\ns_libfile=%s\n",
	       s_init,s_faxdir,s_voicedir,s_libfile);
	printf("s_logfile=%s\ns_lockdir=%s\ns_configfile=%s\n",
	       s_logfile,s_lockdir,s_configfile);
	printf("s_ignore_dle=%d\ns_imon_on_exit=%d\n",
	       s_ignore_dle,s_imon_on_exit);
	printf("s_mail_on_download=%d\ns_mailprog=%s\ns_faxmail=%s\ns_voicemail=%s\n",
	       s_mail_on_download,s_mailprog, s_faxmail, s_voicemail);
	printf("s_tollsaver=%d\ns_loudness=%d\n",s_tollsaver,s_loudness);
	printf("s_viewprog=%s\ns_localscript=%s\n",s_viewprog,s_localscript);
	return(0);
}
int repl_modemstatus(char* const* s) {
 	setiospeed(B19200); 
/*	setiospeed(B115200);*/
	getmodemstatus();
	printf("Current modem status:\n");
	printf("%-19s | %3s | %-15s | %s\n","Option","CMD","command","value");
	printf("--------------------|-----|-----------------|------------\n");
	printf("%-19s | %3s | %-15s | %d\n","SelfMode","MCS","",modemstat.mcs);
	printf("%-19s | %3s | %-15s | %d\n",
	       "Dialup Retrieval","MCD","remote",modemstat.mcd);
	printf("%-19s | %3s | %-15s | %d\n",
	       "Fax receive cap.","MCF","fax",modemstat.mcf);
	printf("%-19s | %3s | %-15s | %d\n",
	       "Voice receive cap.","MCV","voice",modemstat.mcv);
	printf("%-19s | %3s | %-15s | %d\n",
	       "Local Mode (\?\?)","MCL","",modemstat.mcl);
	printf("%-19s | %3s | %-15s | %d\n",
	       "Monitor","MCM","monitor",modemstat.mcm);
	printf("%-19s | %3s | %-15s | %d\n",
	       "Password","MCP","password",modemstat.mcp);
	printf("%-19s | %3s | %-15s | %d\n",
	       "Number of Rings","MCR","answer",modemstat.mcr);
	printf("%-19s | %3s | %-15s | %d\n",
	       "Record time","MVD","set_recordtime",modemstat.mvd);
	printf("%-19s | %3s | %-15s | %s\n",
	       "Clock","MCC","",modemstat.mcc);
	printf("%-19s | %3s | %-15s | %s\n",
	       "Identity","MFI","identity",modemstat.mfi);
	if (modemtypes[s_modemtype].id == USR_MESSAGE_PRO) {
		printf("%-19s | %3s | %-15s | %d\n",
		       "Tollsaver", "MCT", "tollsaver",modemstat.mct);
		printf("%-19s | %3s | %-15s | %d\n",
		       "Loudness", "MCG", "loudness",modemstat.mcg);
	}
	return(0);
}
int repl_version(char* const* s) {
	printf("smmgr %s\n%s\n",VERSION,COPYRIGHT);
	printf("SelfMode Manager, a program to manage a USR MessagePlus, Message56k and similar!\n");
	return(0);
}
int repl_editlocal(char* const* s) {
	char ss[512];
	strcpy(ss,s_localscript);
	strcat(ss," ");
	strcat(ss,s_voicedir);
	strcat(ss," ");
	strcat(ss,s_faxdir);
	return(system(ss));
}
int repl_command(char* const* s) {
	char tmpstr[128];
	char *ret=NULL;
	modemval r;
	if (!device_initialized) {
		logit(L_INFO,"Device not initialize - calling initdevice!\n");
		repl_initdevice(NULL);
	}
 	setiospeed(B38400); 
//	setiospeed(B115200);
	strcpy(tmpstr,*s);
	r = sendstring(tmpstr,&ret,NULL);
	if (r == M_ERROR) {
		logit(L_ERROR,"Got ERROR from modem!\n");
	}
	printf("%s\n",ret);
	free(ret);
	return(0);
}
int repl_set(char* const* s) {
	char *what = s[0];
	char *val  = s[1];
	Setting *set = &comdef_settings[0];
	while (set->name != NULL) {
		if (strcasecmp(what, set->name) == 0) {
			if (!(set->whichmodems & modemtypes[s_modemtype].id)) {
				logit(L_ERROR,"This setting is not valid for modemtype %s!\n",modemtypes[s_modemtype].modemname);
				return(1);
			}
			return((*(set->setfun))(val));
		}
		set++;
	}
	logit(L_ERROR,"Setting %s unknown!\n",what);
	return(1);
}
int repl_showsetting(char* const* s) {
	char *what = s[0];
	int all=0;
	Setting *set = &comdef_settings[0];
		
	printf("------------------------------------\n");
	if (strcasecmp(what,"all") == 0) all=1;
	while (set->name != NULL) {
		if (all==1 || strcasecmp(what, set->name) == 0) {
			printf("Setting:     %s\nDescription: %s\n",set->name,set->description);
			switch (set->t) {
			case S_CHAR:
				printf("Type:        CHAR\nValue:       %s\n",(char*)(set->data));
				break;
			case S_INT:
				printf("Type:        INT\nValue:       %d\n",*(int*)(set->data));
				break;
			case S_BOOL:
				printf("Type:        BOOL\nValue:       %d\n",*(int*)(set->data));
				break;
			}
			printf("------------------------------------\n");
			if (all==0) return(0);
		}
		set++;
	}
	if (all==1) return(0);
	logit(L_ERROR,"Setting %s unknown!\n",what);
	return(1);
}
#ifdef MACRO
/* macro definitions:
   macro bla getmsginfos
   macro doallthejunk "getmsginfos list get all ..."
*/
int repl_macro(char* const* s) {
	char* macnamep=s[0];
	char* macexpp=s[1];
	Tmacdef *nm,*mm;
	char macname[256], macexp[256];
	int found=0;
	strcpy(macname,macnamep);
	strcpy(macexp,macexpp);
	logit(L_DEBUG,"macname=%s, macexp=%s\n",macname,macexp);
	mm=macdef;
	while(mm->name != NULL) {
		logit(L_DEBUG,"We are in the search loop!\n");
		if (strcmp(mm->name,macname) == 0) {
			logit(L_INFO,"Already found a definition for macro %s, replacing!\n",macname);
			found = 1; nm=mm;
			break;
		}
		mm=mm->next;
	}
	if (found == 0) {
		logit(L_DEBUG,"New definition: allocating space!\n");
		fflush(stderr); fflush(stdout);
		nm = (Tmacdef*)malloc(sizeof(Tmacdef));
		nm->next = macdef;
		macdef = nm;
		nm->name = (char*)malloc(strlen(macname)); 
		nm->expansion = (char*)malloc(strlen(macexp));
	} else {
		logit(L_DEBUG,"Old definition: %s=%s\n",nm->name,nm->expansion);
		fflush(stderr); fflush(stdout);
		nm->name = (char*)realloc(nm->name,strlen(macname));
		nm->expansion= (char*)realloc(nm->expansion,strlen(macexp));
	}
	strcpy(nm->name, macname);
	strcpy(nm->expansion,macexp);
	return(0);
}
int repl_showmacros(char* const* s) {
	Tmacdef *nm=macdef;
	if (nm->name == (char*)NULL) {
		printf("No macros defined!\n");
		return(0);
	}
	while (nm->name != (char*)NULL) {
		printf("%-10s  -->  %-50s\n",nm->name, nm->expansion);
		nm = nm->next;
	}
	return(0);
}
#endif
