/* 
  Copyright (C) 1998 Christofer Edvardsen and Norbert Preining

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "smmgr.h"

int set_faxdir(char *s) {
	strncpy(s_faxdir,s,128);
	return(0);
}
int set_voicedir(char *s) {
	strncpy(s_voicedir,s,128);
	c_firstfree = freenr();
	return(0);
}
int set_fax(char *s) {
	if (is_true(s)) s_fax = 1;
	else s_fax = 0;
	return(0);
}
int set_voice(char *s) {
	if (is_true(s)) s_voice = 1;
	else s_voice = 0;
	return(0);
}
int set_monitor(char *s) {
	if (is_true(s)) s_monitor = 1;
	else s_monitor = 0;
	return(0);
}
int set_remote(char *s) {
	if (is_true(s)) s_remote = 1;
	else s_remote = 0;
	return(0);
}
int set_answer(char *s) {
	char *p;
	long int l;

	l = strtol(s,&p,10);
	if (p == NULL || l < 3 || l > 6) {
		logit(L_ERROR,"Syntax error: answer 3|4|5|6\n");
		return(1);
	} else {
		s_answer = l;
		return(0);
	}
}
int set_recordtime(char *s) {
	char *p;
	long int l;
	l = strtol(s,&p,10);
	if (p == NULL || l < 0 || l > 255) {
		logit(L_ERROR,"Syntax error: recordtime [0-255]\n");
		return(1);
	} else {
		s_recordtime = l;
		return(0);
	}
}
int set_password(char *s) {
	char *p;
	long int l;
	l = strtol(s,&p,10);
	if (p == NULL || l < 999 || l > 9999) {
		logit(L_ERROR,"Syntax error: password <4-digit-number>\n");
		return(1);
	} else {
		s_password = l;
		return(0);
	}
}
int set_identity(char *s) {
	strncpy(s_identity,s,21);
	return(0);
}
int set_device(char *s) {
	strncpy(s_device,s,32);
	return(0);
}
int set_verbose(char *s) {
	char *p;
	long int l;

	if (strcasecmp(s,"silent") == 0) {
		s_verbose = L_SILENT;
		return(0);
	}
	if (strcasecmp(s,"error") == 0) {
		s_verbose = L_ERROR;
		return(0);
	}
	if (strcasecmp(s,"info") == 0) {
		s_verbose = L_INFO;
		return(0);
	}
	if (strcasecmp(s,"debug") == 0) {
		s_verbose = L_DEBUG;
		return(0);
	}
	l = strtol(s,&p,10);
	if (p == NULL || l < 0 || l > 3) {
		logit(L_ERROR,"Syntax error: verbose 0|1|2|3\n");
		return(1);
	} else {
		s_verbose = l;
		return(0);
	}
}
int set_initstring(char *s) {
	strncpy(s_init,s,32);
	return(0);
}
int set_libfile(char *s) {
	strncpy(s_libfile,s,256);
	return(0);
}
int set_logfile(char *s) {
	strncpy(s_logfile,s,256);
	return(0);
}
int set_lockdir(char *s) {
	strncpy(s_lockdir,s,256);
	return(0);
}
int set_configfile(char *s) {
	strncpy(s_configfile,s,256);
	return(0);
}
int set_pagesingle(char *s) {
	logit(L_INFO,"Don't use at the moment - buggy! returning ...\n");
	return(0);
	if (is_true(s)) s_pagesingle = 1;
	else s_pagesingle = 0;
	return(0);
}
int set_ignore_dle(char *s) {
	if (is_true(s)) s_ignore_dle = 1;
	else s_ignore_dle = 0;
	return(0);
}
int set_imon_on_exit(char *s) {
	if (is_true(s)) s_imon_on_exit = 1;
	else s_imon_on_exit = 0;
	return(0);
}
int set_mail_on_download(char *s) {
	if (is_true(s)) s_mail_on_download = 1;
	else s_mail_on_download = 0;
	return(0);
}
int set_faxmail(char *s) {
	strncpy(s_faxmail,s,256);
	return(0);
}
int set_out_card(char *s) {
	if (is_true(s)) s_out_card = 1;
	else s_out_card = 0;
	return(0);
}
int set_voicemail(char *s) {
	strncpy(s_voicemail,s,256);
	return(0);
}
int set_mailprog(char *s) {
	strncpy(s_mailprog,s,256);
	return(0);
}
int set_viewprog(char *s) {
	strncpy(s_viewprog,s,256);
	return(0);
}
int set_localscript(char *s) {
	strncpy(s_localscript,s,256);
	return(0);
}
int set_modemtype(char *s) {
        int n=0;
        while (modemtypes[n].modemname != NULL ) {
                if (strcasecmp( s, modemtypes[n].modemname ) == 0) {
                        s_modemtype=n;
                        return(0);
                }
                n++;
        }
        logit(L_INFO,"Modem not found: %s\n",s);
        return(P_NOTFOUND);
}
int set_tollsaver(char *s) {
	if (is_true(s)) s_tollsaver = 1;
	else s_tollsaver = 0;
	return(0);
}
int set_loudness(char *s) {
	char *p;
	long int l;
	l = strtol(s,&p,10);
	if (p == NULL || l < 0 || l > 255) {
		logit(L_ERROR,"Syntax error: loudness <0-255>\n");
		return(1);
	} else {
		s_loudness = l;
		return(0);
	}
}
	
